clear all
%close all

% analize how accuracte the F32, and FloatMathExtended exp2()
% functions are.
% my test harness is inducing excessive error
% num2hex() will turn matlab variables into IEEE single or double floats
% stored as a hex string.
% hex2num() will turn the hex string of a double into a matlab variable.
% hex2dec() translates a hex string into an integer.  

% YES! Matlab File Exchange to the rescue!
% singlehex2num() turns 32-bit hex string containing a single into a matlab
% variable.

%grab the data
data = csvread('exp2_29_drop_resid.csv');

%sort by input
sorted = sortrows(data,1);

%split out each collumn
input = sorted(:,1);
F32 = sorted(:,2);
fme = sorted(:,3);

mat = 2.^input;


%% calculate statistics


%F32
temp = (F32 - mat)./mat ;
F32err = temp;
F32min = min(temp)
F32max = max(temp)
F32std = std(temp)


%FloatMathExtended
temp = (fme - mat)./mat ;
fmeerr = temp;
fmemin = min(temp)
fmemax = max(temp)
fmestd = std(temp)





%% pretty pictures
%plot errors
figure
semilogx(mat, F32err,'b.', mat, fmeerr, 'r.')
grid on
title('Exp2')
legend('F32', 'fme')
xlabel('result')
ylabel('relative error')
% 
% figure
% plot(angle, mat.cos, angle, F32.cos, angle, F_full.cos, angle, fme.cos)
% grid on
% title('cosine')
% legend('matlab', 'F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('value')
% figure
% 
% plot(angle, mat.tan, angle, F32.tan, angle, F_full.tan, angle, fme.tan)
% grid on
% title('tangent')
% legend('matlab', 'F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('value')
% 
% %plot errors.
% figure
% plot(angle, F32.sinerr, angle, F_full.sinerr, angle, fme.sinerr)
% grid on
% title('sine')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('error')
% 
% figure
% plot(angle, F32.coserr, angle, F_full.coserr, angle, fme.coserr)
% grid on
% title('cosine')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('error')
% 
% figure
% plot(angle, F32.tanerr, angle, F_full.tanerr, angle, fme.tanerr)
% grid on
% title('tangent')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('relative error')


