clear all
%close all

% analize how accuracte the F32, and FloatMathExtended exp2()
% functions are.
% my test harness is inducing excessive error
% num2hex() will turn matlab variables into IEEE single or double floats
% stored as a hex string.
% hex2num() will turn the hex string of a double into a matlab variable.
% hex2dec() translates a hex string into an integer.  

% YES! Matlab File Exchange to the rescue!
% singlehex2num() turns 32-bit hex string containing a single into a matlab
% variable.

%grab the data
fid = fopen('tan_test_hex2.csv');
%fid = fopen('NaN.csv');
%fid = fopen('NaN.csv');
%fid = fopen('NaN.csv');
%fid = fopen('NaN.csv');
data = textscan(fid,'%s','Delimiter',',');
fs_error = fclose(fid)

%data is interleved, sort out collums again.
num_col = 3
sz = size(data{1})/num_col
indexes = 1:num_col:sz(1);

%sort by input
%sorted = sortrows(data,1);

%split out each collumn
input = data{1}(indexes);%sorted(:,1);
F32 = data{1}(indexes+1);%sorted(:,2);
fme = data{1}(indexes+2);%sorted(:,3);

%convert to numbers
input = singlehex2num(input);
F32 = singlehex2num(F32);
fme = singlehex2num(fme);


%% calculate statistics

%calculate reference 
mat = tan(input);

%F32
temp = (F32 - mat)./mat ;   %relative error
F32err = temp;
F32min = min(temp)
F32max = max(temp)
F32std = std(temp)


%FloatMathExtended
temp = (fme - mat)./mat;   %relative error
fmeerr = temp;
fmemin = min(temp)
fmemax = max(temp)
fmestd = std(temp)

%compare standard deviations
F32std/fmestd

%% pretty pictures

%plot errors
figure
plot(input, F32err,'b.', input, fmeerr, 'r.')
grid on
title('Exp2')
legend('F32', 'fme')
xlabel('result')
ylabel('relative error')




% 
% figure
% plot(angle, mat.cos, angle, F32.cos, angle, F_full.cos, angle, fme.cos)
% grid on
% title('cosine')
% legend('matlab', 'F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('value')
% figure
% 
% plot(angle, mat.tan, angle, F32.tan, angle, F_full.tan, angle, fme.tan)
% grid on
% title('tangent')
% legend('matlab', 'F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('value')
% 
% %plot errors.
% figure
% plot(angle, F32.sinerr, angle, F_full.sinerr, angle, fme.sinerr)
% grid on
% title('sine')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('error')
% 
% figure
% plot(angle, F32.coserr, angle, F_full.coserr, angle, fme.coserr)
% grid on
% title('cosine')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('error')
% 
% figure
% plot(angle, F32.tanerr, angle, F_full.tanerr, angle, fme.tanerr)
% grid on
% title('tangent')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('relative error')


